import { Component, OnInit, AfterContentInit, OnDestroy, } from '@angular/core';
import { Store, select } from '@ngrx/store';
import { take } from 'rxjs/operators';

import * as AppStore from '../../store';
import { TargetDisplayType } from '../../core/type';

const { saveSvgAsPng, svgAsDataUri } = require('save-svg-as-png');

@Component({
  selector: 'app-menu-export-csv',
  templateUrl: './export-csv.component.html',
  styleUrls: ['./export-csv.component.scss'],
})
export class ExportCSVComponent implements OnInit, AfterContentInit, OnDestroy {

  constructor(
    private store: Store<any>,
  ) {
  }

  ngOnInit(): void {
  }

  ngAfterContentInit(): void {

  }

  ngOnDestroy(): void {

  }

  export() {
    this.store.pipe(
      take(1),
      select((state) => {
        const targetDisplayType = AppStore.TargetSelector.TargetSelector.selectTargetDisplayType(state);
        const targetDisplayElementRef = AppStore.TargetSelector.TargetSelector.selectTargetDisplayElementRef(state);

        if (TargetDisplayType.MAP !== targetDisplayType) {
          return;
        }

        // svgAsDataUri(targetDisplayElementRef.nativeElement, {}, function (uri) {
        //   console.log(`uri: ${uri}`);
        // });
        saveSvgAsPng(targetDisplayElementRef.nativeElement, 'diagram.png', { backgroundColor: '#ffffff' });
      }),
    ).subscribe();
  }
}
